/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _153MP7JRSAUDIOSEGMENTTYPE_LOCALTYPE_H
#define _153MP7JRSAUDIOSEGMENTTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioSegmentType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsAudioSegmentType_LocalType_ExtInclude.h


class IMp7JrsAudioDSType;
class IMp7JrsAudioDType;
class IMp7JrsAudioSegmentType_LocalType;
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;
typedef Mp7JrsPtr< IMp7JrsAudioDType > Mp7JrsAudioDPtr;
typedef Mp7JrsPtr< IMp7JrsAudioSegmentType_LocalType> Mp7JrsAudioSegmentType_LocalPtr;

/** 
 * Generated interface IMp7JrsAudioSegmentType_LocalType for class Mp7JrsAudioSegmentType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioSegmentType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAudioSegmentType_LocalType();
    virtual ~IMp7JrsAudioSegmentType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get AudioDescriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioBPMPtr</li>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBackgroundNoiseLevelPtr</li>
     * <li>IMp7JrsBalancePtr</li>
     * <li>IMp7JrsBandwidthPtr</li>
     * <li>IMp7JrsCrossChannelCorrelationPtr</li>
     * <li>IMp7JrsDcOffsetPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsRelativeDelayPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAudioDescriptor() const = 0;

    /**
     * Set AudioDescriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioBPMPtr</li>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBackgroundNoiseLevelPtr</li>
     * <li>IMp7JrsBalancePtr</li>
     * <li>IMp7JrsBandwidthPtr</li>
     * <li>IMp7JrsCrossChannelCorrelationPtr</li>
     * <li>IMp7JrsDcOffsetPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsRelativeDelayPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * </ul>
     */
    virtual void SetAudioDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get AudioDescriptionScheme element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSignalQualityPtr</li>
     * <li>IMp7JrsAudioSignaturePtr</li>
     * <li>IMp7JrsAudioTempoPtr</li>
     * <li>IMp7JrsErrorEventPtr</li>
     * <li>IMp7JrsHarmonicInstrumentTimbrePtr</li>
     * <li>IMp7JrsInstrumentTimbrePtr</li>
     * <li>IMp7JrsKeyPtr</li>
     * <li>IMp7JrsMelodyContourPtr</li>
     * <li>IMp7JrsMelodySequencePtr</li>
     * <li>IMp7JrsMelodySequenceType_NoteArray_LocalPtr</li>
     * <li>IMp7JrsMelodyPtr</li>
     * <li>IMp7JrsPercussiveInstrumentTimbrePtr</li>
     * <li>IMp7JrsSoundModelStatePathPtr</li>
     * <li>IMp7JrsSpokenContentLatticePtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAudioDescriptionScheme() const = 0;

    /**
     * Set AudioDescriptionScheme element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSignalQualityPtr</li>
     * <li>IMp7JrsAudioSignaturePtr</li>
     * <li>IMp7JrsAudioTempoPtr</li>
     * <li>IMp7JrsErrorEventPtr</li>
     * <li>IMp7JrsHarmonicInstrumentTimbrePtr</li>
     * <li>IMp7JrsInstrumentTimbrePtr</li>
     * <li>IMp7JrsKeyPtr</li>
     * <li>IMp7JrsMelodyContourPtr</li>
     * <li>IMp7JrsMelodySequencePtr</li>
     * <li>IMp7JrsMelodySequenceType_NoteArray_LocalPtr</li>
     * <li>IMp7JrsMelodyPtr</li>
     * <li>IMp7JrsPercussiveInstrumentTimbrePtr</li>
     * <li>IMp7JrsSoundModelStatePathPtr</li>
     * <li>IMp7JrsSpokenContentLatticePtr</li>
     * </ul>
     */
    virtual void SetAudioDescriptionScheme(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioSegmentType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioSegmentType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioSegmentType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 6038.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioSegmentType_LocalType :
        public IMp7JrsAudioSegmentType_LocalType
{
    friend class Mp7JrsAudioSegmentType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get AudioDescriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioBPMPtr</li>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBackgroundNoiseLevelPtr</li>
     * <li>IMp7JrsBalancePtr</li>
     * <li>IMp7JrsBandwidthPtr</li>
     * <li>IMp7JrsCrossChannelCorrelationPtr</li>
     * <li>IMp7JrsDcOffsetPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsRelativeDelayPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAudioDescriptor() const;

    /*
     * Set AudioDescriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioBPMPtr</li>
     * <li>IMp7JrsAudioFundamentalFrequencyPtr</li>
     * <li>IMp7JrsAudioHarmonicityPtr</li>
     * <li>IMp7JrsAudioPowerPtr</li>
     * <li>IMp7JrsAudioSpectrumBasisPtr</li>
     * <li>IMp7JrsAudioSpectrumCentroidPtr</li>
     * <li>IMp7JrsAudioSpectrumEnvelopePtr</li>
     * <li>IMp7JrsAudioSpectrumFlatnessPtr</li>
     * <li>IMp7JrsAudioSpectrumProjectionPtr</li>
     * <li>IMp7JrsAudioSpectrumSpreadPtr</li>
     * <li>IMp7JrsAudioWaveformPtr</li>
     * <li>IMp7JrsBackgroundNoiseLevelPtr</li>
     * <li>IMp7JrsBalancePtr</li>
     * <li>IMp7JrsBandwidthPtr</li>
     * <li>IMp7JrsCrossChannelCorrelationPtr</li>
     * <li>IMp7JrsDcOffsetPtr</li>
     * <li>IMp7JrsHarmonicSpectralCentroidPtr</li>
     * <li>IMp7JrsHarmonicSpectralDeviationPtr</li>
     * <li>IMp7JrsHarmonicSpectralSpreadPtr</li>
     * <li>IMp7JrsHarmonicSpectralVariationPtr</li>
     * <li>IMp7JrsLogAttackTimePtr</li>
     * <li>IMp7JrsMeterPtr</li>
     * <li>IMp7JrsRelativeDelayPtr</li>
     * <li>IMp7JrsSilencePtr</li>
     * <li>IMp7JrsSoundModelStateHistogramPtr</li>
     * <li>IMp7JrsSpectralCentroidPtr</li>
     * <li>IMp7JrsTemporalCentroidPtr</li>
     * </ul>
     */
    virtual void SetAudioDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get AudioDescriptionScheme element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSignalQualityPtr</li>
     * <li>IMp7JrsAudioSignaturePtr</li>
     * <li>IMp7JrsAudioTempoPtr</li>
     * <li>IMp7JrsErrorEventPtr</li>
     * <li>IMp7JrsHarmonicInstrumentTimbrePtr</li>
     * <li>IMp7JrsInstrumentTimbrePtr</li>
     * <li>IMp7JrsKeyPtr</li>
     * <li>IMp7JrsMelodyContourPtr</li>
     * <li>IMp7JrsMelodySequencePtr</li>
     * <li>IMp7JrsMelodySequenceType_NoteArray_LocalPtr</li>
     * <li>IMp7JrsMelodyPtr</li>
     * <li>IMp7JrsPercussiveInstrumentTimbrePtr</li>
     * <li>IMp7JrsSoundModelStatePathPtr</li>
     * <li>IMp7JrsSpokenContentLatticePtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetAudioDescriptionScheme() const;

    /*
     * Set AudioDescriptionScheme element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSignalQualityPtr</li>
     * <li>IMp7JrsAudioSignaturePtr</li>
     * <li>IMp7JrsAudioTempoPtr</li>
     * <li>IMp7JrsErrorEventPtr</li>
     * <li>IMp7JrsHarmonicInstrumentTimbrePtr</li>
     * <li>IMp7JrsInstrumentTimbrePtr</li>
     * <li>IMp7JrsKeyPtr</li>
     * <li>IMp7JrsMelodyContourPtr</li>
     * <li>IMp7JrsMelodySequencePtr</li>
     * <li>IMp7JrsMelodySequenceType_NoteArray_LocalPtr</li>
     * <li>IMp7JrsMelodyPtr</li>
     * <li>IMp7JrsPercussiveInstrumentTimbrePtr</li>
     * <li>IMp7JrsSoundModelStatePathPtr</li>
     * <li>IMp7JrsSpokenContentLatticePtr</li>
     * </ul>
     */
    virtual void SetAudioDescriptionScheme(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioSegmentType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioSegmentType_LocalType();

protected:
    Mp7JrsAudioSegmentType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPtr< Mp7JrsNode > m_AudioDescriptor;
    Mp7JrsPtr< Mp7JrsNode > m_AudioDescriptionScheme;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioSegmentType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _153MP7JRSAUDIOSEGMENTTYPE_LOCALTYPE_H

