/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1379MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE0_H
#define _1379MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMixedCollectionType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType0_ExtInclude.h


class IMp7JrsMixedCollectionType_LocalType0;
class IMp7JrsReferenceType;
class IMp7JrsSegmentType;
typedef Mp7JrsPtr< IMp7JrsMixedCollectionType_LocalType0> Mp7JrsMixedCollectionType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSegmentType > Mp7JrsSegmentPtr;

/** 
 * Generated interface IMp7JrsMixedCollectionType_LocalType0 for class Mp7JrsMixedCollectionType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsMixedCollectionType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMixedCollectionType_LocalType0();
    virtual ~IMp7JrsMixedCollectionType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get Segment element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsTextSegmentPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetSegment() const = 0;

    /**
     * Set Segment element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsTextSegmentPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual void SetSegment(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSegmentRef() const = 0;

    /**
     * Set SegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMixedCollectionType_LocalType0<br>
 * Defined in mpeg7-2004.xsd, line 7890.<br>
 */
class MP7JRS_EXPORT Mp7JrsMixedCollectionType_LocalType0 :
        public IMp7JrsMixedCollectionType_LocalType0
{
    friend class Mp7JrsMixedCollectionType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Segment element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsTextSegmentPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetSegment() const;

    /*
     * Set Segment element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAudioSegmentPtr</li>
     * <li>IMp7JrsAudioVisualRegionPtr</li>
     * <li>IMp7JrsAudioVisualSegmentPtr</li>
     * <li>IMp7JrsCompositionShotPtr</li>
     * <li>IMp7JrsCompositionTransitionPtr</li>
     * <li>IMp7JrsEditedMovingRegionPtr</li>
     * <li>IMp7JrsEditedVideoPtr</li>
     * <li>IMp7JrsGlobalTransitionPtr</li>
     * <li>IMp7JrsImageTextPtr</li>
     * <li>IMp7JrsInkSegmentPtr</li>
     * <li>IMp7JrsInternalTransitionPtr</li>
     * <li>IMp7JrsIntraCompositionShotPtr</li>
     * <li>IMp7JrsMosaicPtr</li>
     * <li>IMp7JrsMovingRegionPtr</li>
     * <li>IMp7JrsMultimediaSegmentPtr</li>
     * <li>IMp7JrsShotPtr</li>
     * <li>IMp7JrsStillRegion3DPtr</li>
     * <li>IMp7JrsStillRegionPtr</li>
     * <li>IMp7JrsTextSegmentPtr</li>
     * <li>IMp7JrsVideoSegmentPtr</li>
     * <li>IMp7JrsVideoTextPtr</li>
     * </ul>
     */
    virtual void SetSegment(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SegmentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSegmentRef() const;

    /*
     * Set SegmentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSegmentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMixedCollectionType_LocalType0();

protected:
    Mp7JrsMixedCollectionType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPtr< Mp7JrsNode > m_Segment;
    Mp7JrsReferencePtr m_SegmentRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsMixedCollectionType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1379MP7JRSMIXEDCOLLECTIONTYPE_LOCALTYPE0_H

